Imports Microsoft.VisualBasic
Imports System.Data.SqlClient
Imports System.Configuration

Public Class clsCalenders
    Inherits ArrayList

    Public Sub LoadAll()
        Dim objConn As SqlConnection = Nothing
        Dim objCmd As SqlCommand
        Dim objReader As SqlDataReader = Nothing

        Try
            objConn = New SqlConnection(ConfigurationManager.ConnectionStrings("CMSDatabase").ConnectionString)
            objConn.Open()

            objCmd = New SqlCommand("dbo.usp_Calendars_GetAll", objConn)
            objCmd.CommandType = Data.CommandType.StoredProcedure

            objReader = objCmd.ExecuteReader()

            Me.Clear()

            Do While objReader.Read
                Add(New clsCalender(objReader("ID"), objReader("Name").ToString()))
            Loop
        Catch ex As Exception
            Throw New Exception("clsRecurTypes.LoadAll - " & ex.Message)
        Finally
            If Not objReader Is Nothing Then objReader.Close()
            If Not objConn Is Nothing Then objConn.Close()
        End Try
    End Sub
End Class

Public Class clsCalender
    Private Structure CalenderProps
        Public ID As Integer
        Public Name As String
    End Structure

    Private mudsProps As CalenderProps

    Public Sub New(ByVal pID As Integer, ByVal pName As String)
        mudsProps.ID = pID
        mudsProps.Name = pName
    End Sub

    Public ReadOnly Property ID() As Integer
        Get
            Return mudsProps.ID
        End Get
    End Property

    Public ReadOnly Property Name() As String
        Get
            Return mudsProps.Name
        End Get
    End Property

    Public Sub Save(ByVal pValue As String)
        Dim objConn As SqlConnection = Nothing
        Dim objCmd As SqlCommand

        Try
            objConn = New SqlConnection(ConfigurationManager.ConnectionStrings("CMSDatabase").ConnectionString)
            objConn.Open()

            objCmd = New SqlCommand("usp_Calendars_Save", objConn)
            objCmd.CommandType = Data.CommandType.StoredProcedure
            objCmd.Parameters.AddWithValue("@pID", ID)
            objCmd.Parameters.AddWithValue("@pName", pValue)

            objCmd.ExecuteNonQuery()

        Catch ex As Exception
            Throw New Exception("clsCalender.Save - " & ex.Message)
        Finally
            If Not objConn Is Nothing Then objConn.Close()
        End Try
    End Sub

    Public Sub Delete()
        Dim objConn As SqlConnection = Nothing
        Dim objCmd As SqlCommand

        Try
            objConn = New SqlConnection(ConfigurationManager.ConnectionStrings("CMSDatabase").ConnectionString)
            objConn.Open()

            objCmd = New SqlCommand("usp_Calendars_Delete", objConn)
            objCmd.CommandType = Data.CommandType.StoredProcedure
            objCmd.Parameters.AddWithValue("@pID", ID)

            objCmd.ExecuteNonQuery()

        Catch ex As Exception
            Throw New Exception("clsCalender.Delete - " & ex.Message)
        Finally
            If Not objConn Is Nothing Then objConn.Close()
        End Try
    End Sub
End Class
