Imports Microsoft.VisualBasic
Imports System.Data.SqlClient
Imports System.Configuration

Public Class clsRecurEventList
    Inherits ArrayList

    Public Sub LoadbyDateRange(ByVal pCalendar As Integer, ByVal pStartDate As Date, ByVal pEndDate As Date)
        Dim objConn As SqlConnection = Nothing
        Dim objCmd As SqlCommand
        Dim objReader As SqlDataReader = Nothing

        Try
            objConn = New SqlConnection(ConfigurationManager.ConnectionStrings("CMSDatabase").ConnectionString)
            objConn.Open()

            objCmd = New SqlCommand("dbo.usp_RecurEvents_by_Date_Range", objConn)
            objCmd.CommandType = Data.CommandType.StoredProcedure
            objCmd.Parameters.AddWithValue("@pCalendar", pCalendar)
            objCmd.Parameters.AddWithValue("@pStartDate", pStartDate)
            objCmd.Parameters.AddWithValue("@pEndDate", pEndDate)

            objReader = objCmd.ExecuteReader()

            Me.Clear()

            Do While objReader.Read
                Add(New clsRecurEvent(objReader("ID"), objReader("Title").ToString(), objReader("Description").ToString(), objReader("StartDate"), objReader("EndDate"), objReader("StartTime"), objReader("EndTime"), objReader("RecurType"), objReader("RecurType").ToString(), objReader("Calendar")))
            Loop
        Catch ex As Exception
            Throw New Exception("clsRecurEventList.LoadbyDateRange - " & ex.Message)
        Finally
            If Not objReader Is Nothing Then objReader.Close()
            If Not objConn Is Nothing Then objConn.Close()
        End Try
    End Sub

    Public Sub LoadAll()
        Dim objConn As SqlConnection = Nothing
        Dim objCmd As SqlCommand
        Dim objReader As SqlDataReader = Nothing

        Try
            objConn = New SqlConnection(ConfigurationManager.ConnectionStrings("CMSDatabase").ConnectionString)
            objConn.Open()

            objCmd = New SqlCommand("dbo.usp_RecurEvents_LoadAll", objConn)
            objCmd.CommandType = Data.CommandType.StoredProcedure

            objReader = objCmd.ExecuteReader()

            Me.Clear()

            Do While objReader.Read
                Add(New clsRecurEvent(objReader("ID"), objReader("Title").ToString(), objReader("Description").ToString(), objReader("StartDate"), objReader("EndDate"), objReader("StartTime"), objReader("EndTime"), objReader("RecurType"), objReader("RecurTypeStr").ToString(), objReader("Calendar")))
            Loop
        Catch ex As Exception
            Throw New Exception("clsRecurEventList.LoadAll - " & ex.Message)
        Finally
            If Not objReader Is Nothing Then objReader.Close()
            If Not objConn Is Nothing Then objConn.Close()
        End Try
    End Sub
End Class
