Imports Microsoft.VisualBasic
Imports System.Data.SqlClient
Imports System.Configuration

Public Class clsStyleList
    Inherits ArrayList

    Public Overloads ReadOnly Property Item(ByVal pID As Integer) As clsStyle
        Get
            Dim objStyle As clsStyle = Nothing
            For I As Integer = 0 To Count - 1
                If Me(I).ID = pID Then
                    objStyle = Me(I)
                    Exit For
                End If
            Next I
            Return objStyle
        End Get
    End Property

    Public Sub LoadStylesbyControl(ByVal pControl As String)
        Dim objConn As SqlConnection = Nothing
        Dim objCmd As SqlCommand
        Dim objReader As SqlDataReader = Nothing

        Try
            objConn = New SqlConnection(ConfigurationManager.ConnectionStrings("CMSDatabase").ConnectionString)
            objConn.Open()

            objCmd = New SqlCommand("usp_Styles_by_Control", objConn)
            objCmd.CommandType = Data.CommandType.StoredProcedure
            objCmd.Parameters.AddWithValue("@pControl", pControl)

            objReader = objCmd.ExecuteReader()

            Me.Clear()

            Do While objReader.Read
                Add(New clsStyle(objReader("ID"), objReader("Control").ToString(), objReader("StyleKey").ToString(), objReader("StyleValue").ToString()))
            Loop
        Catch ex As Exception
            Throw New Exception("clsStyleList.LoadStylesbyControl - " & ex.Message)
        Finally
            If Not objReader Is Nothing Then objReader.Close()
            If Not objConn Is Nothing Then objConn.Close()
        End Try
    End Sub

    Public Sub LoadAll()
        Dim objConn As SqlConnection = Nothing
        Dim objCmd As SqlCommand
        Dim objReader As SqlDataReader = Nothing

        Try
            objConn = New SqlConnection(ConfigurationManager.ConnectionStrings("CMSDatabase").ConnectionString)
            objConn.Open()

            objCmd = New SqlCommand("usp_Styles_GetAll", objConn)
            objCmd.CommandType = Data.CommandType.StoredProcedure


            objReader = objCmd.ExecuteReader()

            Me.Clear()

            Do While objReader.Read
                Add(New clsStyle(objReader("ID"), objReader("Control").ToString(), objReader("StyleKey").ToString(), objReader("StyleValue").ToString()))
            Loop
        Catch ex As Exception
            Throw New Exception("clsStyleList.LoadAll - " & ex.Message)
        Finally
            If Not objReader Is Nothing Then objReader.Close()
            If Not objConn Is Nothing Then objConn.Close()
        End Try
    End Sub
End Class
